unit ExpUtils;
{*******************************************************************************
                                ExpUtils
[CZX]
  {\tgEFA LGPL2(not 2.1) ŔzzĂ܂B

  Eۏ
    ύX҂͖{\tgEFA̎gpɋN邠鑹QEQɂĂ̐ӔC
    ؕȂ̂Ƃ܂B܂oOC̋`𕉂Ȃ̂Ƃ܂B
  Egp
    pA񏤗p킸RɎgpĂ܂܂Bgp\Kv܂B
  EA[JCu̕ύX
    ƎA[JCuɊ܂߂čĔzzĂ܂܂B𓾂Kv܂B
  Eϔłzz
    ȉ[ύX]ɕύX_AύX҂L̏ LGPL2 ŔzzĂB

  EĂ͂Ȃ
    {\tgEFA܂͉ϔłCZXύX(LGPL2 ȊO)zz邱ƁB

[ύX]
v1.00   2002/09/29 t_kumagai@ot.olympus.co.jp(http://kuma.webj.net/)
  EVK쐬
*******************************************************************************}

interface

uses
  Classes;

function ExpToInt(const Expr: string; const IdentList: TStrings = nil): Integer;
function ExpToIntDef(const Expr: string; DefValue: Integer; const IdentList: TStrings = nil): Integer;
function ExpToFloat(const Expr: string; const IdentList: TStrings = nil): Double;
function ExpToFloatDef(const Expr: string; DefValue: Double; const IdentList: TStrings = nil): Double;
function CustomExpToFloat(const Expr: string; const ValueList, UserList, CycleList: TStrings): Double;

implementation

uses
  SysUtils, ExpYacc, ExpLex;

const
  rcsid: string = '$Id: ExpUtils.pas,v 1.3 2002/09/24 23:47:32 kumagai Exp $';

var
  ConstList: TStrings;

function ExpToInt(const Expr: string; const IdentList: TStrings = nil): Integer;
var
  D: Double;
begin
  D := ExpToFloat(Expr, IdentList);
  if (D <> Trunc(D)) then
    raise Exception.Create(Expr + ' is not Integer');
  Result := Trunc(D);
end;

function ExpToIntDef(const Expr: string; DefValue: Integer; const IdentList: TStrings = nil): Integer;
begin
  try
    Result := ExpToInt(Expr, IdentList);
  except
    Result := DefValue;
  end;
end;

function ExpToFloat(const Expr: string; const IdentList: TStrings = nil): Double;
  procedure ParseIdentList(VL, UL: TStrings);
  var
    I, R, L: Integer;
    Name: string;
  begin
    for I := 0 to IdentList.Count - 1 do
    begin
      Name := StringReplace(IdentList.Names[I], ' ', '', []);
      L := Pos('(', Name);
      R := Pos(')', Name);
      if ((L = 0) and (R = 0)) then
      begin
        VL.Add(IdentList[I]);
      end else if ((L > 0) and (R > L)) then
      begin
        Name[L] := ' ';
        Name[R] := ' ';
        if ((Pos('(', Name) <> 0) or (Pos(')', Name) <> 0)) then
          raise Exception.Create('Invalid Function:' + IdentList[I]);
        with (TStringList.Create) do
        try
          Add(Copy(Name, L + 1, R - L - 1));
          Add(IdentList.Values[IdentList.Names[I]]);
          UL.Values[Copy(Name, 1, L - 1)] := CommaText;
        finally
          Free;
        end;
      end else
        raise Exception.Create('Invalid Ident:' + IdentList[I]);
    end;
  end;
var
  VL, UL, CL: TStrings;
begin
  VL := TStringList.Create;
  UL := TStringList.Create;
  CL := TStringList.Create;
  VL.AddStrings(ConstList);
  try
    if (Assigned(IdentList)) then
      ParseIdentList(VL, UL);
    Result := CustomExpToFloat(Expr, VL, UL, CL);
  finally
    VL.Free;
    UL.Free;
    CL.Free;
  end;
end;

function ExpToFloatDef(const Expr: string; DefValue: Double; const IdentList: TStrings = nil): Double;
begin
  try
    Result := ExpToFloat(Expr, IdentList);
  except
    Result := DefValue;
  end;
end;

function CustomExpToFloat(const Expr: string; const ValueList, UserList, CycleList: TStrings): Double;
var
  Lex: TLex;
  Yacc: TYacc;
begin
  Lex := TLex.Create;
  Yacc := TYacc.Create(Lex);
  try
    Yacc.Init(ValueList, UserList, CycleList);
    Lex.InputString:= Expr;
    Yacc.yyparse;
    Result := Yacc.Value;
  finally
    Yacc.Term;
    Yacc.Free;
    Lex.Free;
  end;
end;

initialization
  ConstList := TStringList.Create;
  ConstList.Values['PI'] := '3.14159265358979323846';

finalization
  ConstList.Free;

end.
