//
// Yacc ev[g for Delphi
//      by Osamu TAKEUCHI <osamu@big.or.jp>
//         http://www2.big.or.jp/~osamu/
//
//   Yacc ev[ggƁAb͂ TYacc ƂNX
//  ܂ރjbg *.Y t@C玩邱Ƃł܂B
//
//  TYacc ͂̃ev[gƂƂɔzz YaccLib Ɏ TYaccBase
//  NX̎qƂȂ܂B
//
//  YaccLib.TYaccBase ̓JX^}CY邽 TYaccBase hNX
//  pӂATYacc ͂̃NXh邱Ƃł܂B
//
//  R[h́Apꂽ YaccLib.TYaccBase ̎qNXK
//  SomeUnit.TYaccBase ̌`̖O̂Ɖ肵܂B
//
//  .L  definitions ZNVɂ͕K
//  %{
//      unit UnitName;
//      interface
//      uses LexLib, SomeYaccLib;
//  %}
//  ̂TsLqĂB
//  UnitName  *.l t@C * ƓO
//  SomeYaccLib  TYaccBase NX񋟂郆jbg
//  LexLib ͂ COD ƂƂɔzz LexLib jbg
//  ̑Kvȃjbg uses 邱Ƃł܂
//  ̑KvȃO[o錾ɒǉ邱Ƃł܂
//
//  .L  rules ZNV̐擪 TYacc ̃o[錾ǉ邱Ƃł܂B
//    private
//      procedure SomeUtility;
//  sɃzCgXy[XȂ΂ȂȂƂɒӂĂB
//
//  .L  axiliary procedures ZNVɂ rules ZNVŒǉ錾
//  Ή`Ƃł܂B
//      procedure TYacc.SomeUtility;
//      begin
//
//      end;
//
//  oオ SomeYacc.pas jbĝ͎悤ɂĎgƂł܂B
//  ł TLexBase Ƃ LexLib_Stream.TLexBase gpƉ肵܂B
//
//    uses
//      SomeLex,        // lex  ɂ SomeLex.l  玩
//      SomeYacc;       // yacc ɂ SomeYacc.y 玩
//
//    var lex: TLex;    // lex  ɂ莩ꂽ SomeLex  Ɏ
//        yacc: TYacc;  // yacc ɂ莩ꂽ SomeYacc Ɏ
//    begin
//        lex := nil;
//        yacc:= nil;
//        try
//            lex := TLex.Create;
//            lex.InputString:= 'x=2*(3+2)'#10'x*3'#10;
//            yacc:= TYacc.Create(lex); // yacc  lex 蓖Ă
//            yacc.yyparse;             // p[XsI
//        finally
//            yacc.Free;
//            lex.Free;
//        end;
//    end.
//

{$B-}

///////////////////////////////////////////////////////
// .Y ɋLqꂽꂽ unit/interface/uses
///////////////////////////////////////////////////////


{*******************************************************************************
                                ExpYacc
[CZX]
  {\tgEFA LGPL2(not 2.1) ŔzzĂ܂B

  Eۏ
    ύX҂͖{\tgEFA̎gpɋN邠鑹QEQɂĂ̐ӔC
    ؕȂ̂Ƃ܂B܂oOC̋`𕉂Ȃ̂Ƃ܂B
  Egp
    pA񏤗p킸RɎgpĂ܂܂Bgp\Kv܂B
  EA[JCu̕ύX
    ƎA[JCuɊ܂߂čĔzzĂ܂܂B𓾂Kv܂B
  Eϔłzz
    ȉ[ύX]ɕύX_AύX҂L̏ LGPL2 ŔzzĂB

  EĂ͂Ȃ
    {\tgEFA܂͉ϔłCZXύX(LGPL2 ȊO)zz邱ƁB

[ύX]
v1.00   2002/09/29 t_kumagai@ot.olympus.co.jp(http://kuma.webj.net/)
  EVK쐬
*******************************************************************************}

unit ExpYacc;

interface

uses SysUtils, LexLib, YaccLib, Classes, Math, ExpUtils;

const
  E_UNDEFINED_IDENT = 'Undefined Ident:';	// `̕ϐ
  E_INVALID_FUNCTION = 'Invalid function:';	// Ȋ֐Ăяo
  E_INVALID_PARAM = 'Invalid parameter:';	// ֐p[^Ⴄ
  E_ZERO_DIVIDE = 'Zero Divide:';			// [ɂ鏜Z
  E_VALUE_NOT_ENOUGH = 'Value not enouth:';	// ls
  E_CIRCULATION = 'Circulation:';			// zQ


const NUMBER = 257;
const IDENT = 258;
const UNARYOP = 259;
const ILLEGAL = 260;

type YYSType = record case Integer of
                 1 : ( yyDouble : Double );
                 2 : ( yyInteger : Integer );
                 3 : ( yyPChar : PChar );
               end(*YYSType*);

///////////////////////////////////////////////////////

var yylval : YYSType;

type
TYacc = class (TYaccBase)

  private
    ValueStack: array of Double;
    FunctionList: TStrings;
    UserList: TStrings;
    ValueList: TStrings;
    CycleList: TStrings;
  protected
    // G[ override
    procedure yyerror(Msg: string); override;
    procedure YYAssert(Cond: Boolean; Msg: string);
    function SetValue(Value: Double): Double;
    function IdentToValue(const ID: string): Double;
    procedure PushStack(Value: Double);
    function PopStack: Double;
    function TopStack: PDouble;
    function CountStack: Integer;
    function OpUserFunc(FuncName, FuncDef: string; N: Integer; P: PDouble): Double;
    function CallFunction(const ID: string; ArgCount: Integer): Double;
  public
    Value: Double;
    procedure Init(VL, UL, CL: TStrings; MaxStackSize: Integer = 64);
    procedure Term;
  public
    yylex : TLexBase;
    function yyparse: Integer;
    constructor Create(lex: TLexBase);
end;

implementation

///////////////////////////////////////////////////////

constructor TYacc.Create(lex: TLexBase);
begin
    yylex:= lex;
end;

function TYacc.yyparse : Integer;

var yystate, yysp, yyn : Integer;
    yys : array of Integer;
    yyv : array of YYSType;
    yyval : YYSType;

procedure yyaction ( yyruleno : Integer );
begin(*yyaction*)
  (* actions: *)
  case yyruleno of
   1 : begin
         SetValue(yyv[yysp-0].yyDouble); 
       end;
   2 : begin
         
       end;
   3 : begin
         yyval.yyDouble := yyv[yysp-2].yyDouble + yyv[yysp-0].yyDouble; 
       end;
   4 : begin
         yyval.yyDouble := yyv[yysp-2].yyDouble - yyv[yysp-0].yyDouble; 
       end;
   5 : begin
         yyval.yyDouble := yyv[yysp-2].yyDouble * yyv[yysp-0].yyDouble; 
       end;
   6 : begin
         
         											YYAssert(yyv[yysp-0].yyDouble <> 0, E_ZERO_DIVIDE + yylex.yytext);
         											yyval.yyDouble := yyv[yysp-2].yyDouble / yyv[yysp-0].yyDouble;
         										
       end;
   7 : begin
         yyval.yyDouble := Power(yyv[yysp-2].yyDouble, yyv[yysp-0].yyDouble); 
       end;
   8 : begin
         yyval.yyDouble := -yyv[yysp-0].yyDouble; 
       end;
   9 : begin
         yyval.yyDouble := yyv[yysp-0].yyDouble; 
       end;
  10 : begin
         yyval.yyDouble := yyv[yysp-1].yyDouble; 
       end;
  11 : begin
         yyval.yyDouble := yyv[yysp-0].yyDouble; 
       end;
  12 : begin
         yyval.yyDouble := IdentToValue(yyv[yysp-0].yyPChar); 
       end;
  13 : begin
         yyval.yyDouble := CallFunction(yyv[yysp-3].yyPChar, yyv[yysp-1].yyInteger); 
       end;
  14 : begin
         yyval.yyInteger := 0; 
       end;
  15 : begin
         yyval.yyInteger := yyv[yysp-0].yyInteger; 
       end;
  16 : begin
         yyval.yyInteger := 1; PushStack(yyv[yysp-0].yyDouble); 
       end;
  17 : begin
         Inc(yyval.yyInteger); PushStack(yyv[yysp-2].yyDouble); 
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 127;
yyngotos  = 15;
yynstates = 30;
yynrules  = 17;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 256; act: 6 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 1: }
  ( sym: 0; act: 0 ),
{ 2: }
  ( sym: 42; act: 9 ),
  ( sym: 43; act: 10 ),
  ( sym: 45; act: 11 ),
  ( sym: 47; act: 12 ),
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -1 ),
{ 3: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 4: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 5: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 6: }
{ 7: }
{ 8: }
  ( sym: 40; act: 17 ),
  ( sym: 0; act: -12 ),
  ( sym: 41; act: -12 ),
  ( sym: 42; act: -12 ),
  ( sym: 43; act: -12 ),
  ( sym: 44; act: -12 ),
  ( sym: 45; act: -12 ),
  ( sym: 47; act: -12 ),
  ( sym: 94; act: -12 ),
{ 9: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 10: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 11: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 12: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 13: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
{ 14: }
  ( sym: 41; act: 23 ),
  ( sym: 42; act: 9 ),
  ( sym: 43; act: 10 ),
  ( sym: 45; act: 11 ),
  ( sym: 47; act: 12 ),
  ( sym: 94; act: 13 ),
{ 15: }
{ 16: }
{ 17: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 ),
  ( sym: 41; act: -14 ),
{ 18: }
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -5 ),
  ( sym: 41; act: -5 ),
  ( sym: 42; act: -5 ),
  ( sym: 43; act: -5 ),
  ( sym: 44; act: -5 ),
  ( sym: 45; act: -5 ),
  ( sym: 47; act: -5 ),
{ 19: }
  ( sym: 42; act: 9 ),
  ( sym: 47; act: 12 ),
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -3 ),
  ( sym: 41; act: -3 ),
  ( sym: 43; act: -3 ),
  ( sym: 44; act: -3 ),
  ( sym: 45; act: -3 ),
{ 20: }
  ( sym: 42; act: 9 ),
  ( sym: 47; act: 12 ),
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -4 ),
  ( sym: 41; act: -4 ),
  ( sym: 43; act: -4 ),
  ( sym: 44; act: -4 ),
  ( sym: 45; act: -4 ),
{ 21: }
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -6 ),
  ( sym: 41; act: -6 ),
  ( sym: 42; act: -6 ),
  ( sym: 43; act: -6 ),
  ( sym: 44; act: -6 ),
  ( sym: 45; act: -6 ),
  ( sym: 47; act: -6 ),
{ 22: }
  ( sym: 94; act: 13 ),
  ( sym: 0; act: -7 ),
  ( sym: 41; act: -7 ),
  ( sym: 42; act: -7 ),
  ( sym: 43; act: -7 ),
  ( sym: 44; act: -7 ),
  ( sym: 45; act: -7 ),
  ( sym: 47; act: -7 ),
{ 23: }
{ 24: }
{ 25: }
  ( sym: 41; act: 27 ),
{ 26: }
  ( sym: 42; act: 9 ),
  ( sym: 43; act: 10 ),
  ( sym: 44; act: 28 ),
  ( sym: 45; act: 11 ),
  ( sym: 47; act: 12 ),
  ( sym: 94; act: 13 ),
  ( sym: 41; act: -16 ),
{ 27: }
{ 28: }
  ( sym: 40; act: 3 ),
  ( sym: 43; act: 4 ),
  ( sym: 45; act: 5 ),
  ( sym: 257; act: 7 ),
  ( sym: 258; act: 8 )
{ 29: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -5; act: 1 ),
  ( sym: -2; act: 2 ),
{ 1: }
{ 2: }
{ 3: }
  ( sym: -2; act: 14 ),
{ 4: }
  ( sym: -2; act: 15 ),
{ 5: }
  ( sym: -2; act: 16 ),
{ 6: }
{ 7: }
{ 8: }
{ 9: }
  ( sym: -2; act: 18 ),
{ 10: }
  ( sym: -2; act: 19 ),
{ 11: }
  ( sym: -2; act: 20 ),
{ 12: }
  ( sym: -2; act: 21 ),
{ 13: }
  ( sym: -2; act: 22 ),
{ 14: }
{ 15: }
{ 16: }
{ 17: }
  ( sym: -4; act: 24 ),
  ( sym: -3; act: 25 ),
  ( sym: -2; act: 26 ),
{ 18: }
{ 19: }
{ 20: }
{ 21: }
{ 22: }
{ 23: }
{ 24: }
{ 25: }
{ 26: }
{ 27: }
{ 28: }
  ( sym: -4; act: 29 ),
  ( sym: -2; act: 26 )
{ 29: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } 0,
{ 5: } 0,
{ 6: } -2,
{ 7: } -11,
{ 8: } 0,
{ 9: } 0,
{ 10: } 0,
{ 11: } 0,
{ 12: } 0,
{ 13: } 0,
{ 14: } 0,
{ 15: } -9,
{ 16: } -8,
{ 17: } 0,
{ 18: } 0,
{ 19: } 0,
{ 20: } 0,
{ 21: } 0,
{ 22: } 0,
{ 23: } -10,
{ 24: } -15,
{ 25: } 0,
{ 26: } 0,
{ 27: } -13,
{ 28: } 0,
{ 29: } -17
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 7,
{ 2: } 8,
{ 3: } 14,
{ 4: } 19,
{ 5: } 24,
{ 6: } 29,
{ 7: } 29,
{ 8: } 29,
{ 9: } 38,
{ 10: } 43,
{ 11: } 48,
{ 12: } 53,
{ 13: } 58,
{ 14: } 63,
{ 15: } 69,
{ 16: } 69,
{ 17: } 69,
{ 18: } 75,
{ 19: } 83,
{ 20: } 91,
{ 21: } 99,
{ 22: } 107,
{ 23: } 115,
{ 24: } 115,
{ 25: } 115,
{ 26: } 116,
{ 27: } 123,
{ 28: } 123,
{ 29: } 128
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 6,
{ 1: } 7,
{ 2: } 13,
{ 3: } 18,
{ 4: } 23,
{ 5: } 28,
{ 6: } 28,
{ 7: } 28,
{ 8: } 37,
{ 9: } 42,
{ 10: } 47,
{ 11: } 52,
{ 12: } 57,
{ 13: } 62,
{ 14: } 68,
{ 15: } 68,
{ 16: } 68,
{ 17: } 74,
{ 18: } 82,
{ 19: } 90,
{ 20: } 98,
{ 21: } 106,
{ 22: } 114,
{ 23: } 114,
{ 24: } 114,
{ 25: } 115,
{ 26: } 122,
{ 27: } 122,
{ 28: } 127,
{ 29: } 127
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 3,
{ 2: } 3,
{ 3: } 3,
{ 4: } 4,
{ 5: } 5,
{ 6: } 6,
{ 7: } 6,
{ 8: } 6,
{ 9: } 6,
{ 10: } 7,
{ 11: } 8,
{ 12: } 9,
{ 13: } 10,
{ 14: } 11,
{ 15: } 11,
{ 16: } 11,
{ 17: } 11,
{ 18: } 14,
{ 19: } 14,
{ 20: } 14,
{ 21: } 14,
{ 22: } 14,
{ 23: } 14,
{ 24: } 14,
{ 25: } 14,
{ 26: } 14,
{ 27: } 14,
{ 28: } 14,
{ 29: } 16
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 2,
{ 1: } 2,
{ 2: } 2,
{ 3: } 3,
{ 4: } 4,
{ 5: } 5,
{ 6: } 5,
{ 7: } 5,
{ 8: } 5,
{ 9: } 6,
{ 10: } 7,
{ 11: } 8,
{ 12: } 9,
{ 13: } 10,
{ 14: } 10,
{ 15: } 10,
{ 16: } 10,
{ 17: } 13,
{ 18: } 13,
{ 19: } 13,
{ 20: } 13,
{ 21: } 13,
{ 22: } 13,
{ 23: } 13,
{ 24: } 13,
{ 25: } 13,
{ 26: } 13,
{ 27: } 13,
{ 28: } 15,
{ 29: } 15
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 1; sym: -5 ),
{ 2: } ( len: 1; sym: -5 ),
{ 3: } ( len: 3; sym: -2 ),
{ 4: } ( len: 3; sym: -2 ),
{ 5: } ( len: 3; sym: -2 ),
{ 6: } ( len: 3; sym: -2 ),
{ 7: } ( len: 3; sym: -2 ),
{ 8: } ( len: 2; sym: -2 ),
{ 9: } ( len: 2; sym: -2 ),
{ 10: } ( len: 3; sym: -2 ),
{ 11: } ( len: 1; sym: -2 ),
{ 12: } ( len: 1; sym: -2 ),
{ 13: } ( len: 4; sym: -2 ),
{ 14: } ( len: 0; sym: -3 ),
{ 15: } ( len: 1; sym: -3 ),
{ 16: } ( len: 1; sym: -4 ),
{ 17: } ( len: 3; sym: -4 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)
  SetLength(yys, yymaxdepth);
  SetLength(yyv, yymaxdepth);
  yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;
  yylex.yyinit;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>Length(yys)-1 then begin
      SetLength(yys, Length(yys)*2);
      SetLength(yyv, Length(yyv)*2);
  end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex.yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then yylex.yywriteln('state '+IntToStr(yystate)+', char '+IntToStr(yychar) );

  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error');

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              yylex.yywriteln('error recovery pops state '+IntToStr(yys[yysp])+', uncovers '
                      +IntToStr(yys[yysp-1]))
            else
              yylex.yywriteln('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then yylex.yywriteln('error recovery discards char '+IntToStr(yychar));
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then yylex.yywriteln('reduce '+IntToStr(-yyn));

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0;
  yylex.yyfinal;
  exit;

abort:

  yyparse := 1;
  yylex.yyfinal;
  exit;

end(*yyparse*);


// G[ override
procedure TYacc.yyerror (Msg : String );
var
  S: string;
begin
  S := yylex.yytext;
  yylex.yywriteln(Msg +
    ' around ''' + S + '''' +
    ' at L' + IntToStr(yylex.yylineno) +
    ':C' + IntToStr(yylex.yycolno));
  inherited yyerror(Msg);
end;

procedure YYAssert(Cond: Boolean; Msg: string);
begin
  if (Cond) then
    Exit;
  raise Exception.Create(Msg);
end;

procedure TYacc.YYAssert(Cond: Boolean; Msg: string);
begin
  ExpYacc.YYAssert(Cond, Msg);
end;

function TYacc.SetValue(Value: Double): Double;
begin
  Self.Value := Value;
  Result := Value;
end;

function TYacc.IdentToValue(const ID: string): Double;
begin
  YYAssert(ValueList.Values[ID] <> '', E_UNDEFINED_IDENT + ID);
  YYAssert(CycleList.IndexOf(ID) = -1, E_CIRCULATION);
  CycleList.Insert(0, ID);
  Result := CustomExpToFloat(ValueList.Values[ID], ValueList, UserList, CycleList);
  CycleList.Delete(0);
end;

procedure TYacc.PushStack(Value: Double);
var
  N: Integer;
begin
  N := CountStack;
  SetLength(ValueStack, N + 1);
  ValueStack[N] := Value;
end;

function TYacc.PopStack: Double;
var
  N: Integer;
begin
  N := CountStack;
  Result := ValueStack[N - 1];
  SetLength(ValueStack, N - 1);
end;

function TYacc.TopStack: PDouble;
begin
  Result := @ValueStack[CountStack - 1];
end;

function TYacc.CountStack: Integer;
begin
  Result := Length(ValueStack);
end;

function OpSum(N: Integer; P: PDouble): Double;
var
  I: Integer;
begin
  Result := 0;
  for I := 0 to N - 1 do
  begin
    Result := Result + P^;
    Inc(P);
  end;
end;

function OpAverage(N: Integer; P: PDouble): Double;
begin
  YYAssert(N > 0, E_VALUE_NOT_ENOUGH);
  Result := OpSum(N, P) / N;
end;

function OpStdev(N: Integer; P: PDouble): Double;
var
  S, S2: Double;
  I: Integer;
begin
  YYAssert(N > 1,  E_VALUE_NOT_ENOUGH);
  S := 0;
  S2 := 0;
  for I := 0 to N - 1 do
  begin
    S := S + P^;
    S2 := S2 + Sqr(P^);
    Inc(P);
  end;
  Result := Sqrt(N * S2 - Sqr(S)) / (N * (N - 1));
end;

function OpAbs(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Abs(P^);
end;

function OpSin(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Sin(P^);
end;

function OpCos(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Cos(P^);
end;

function OpTan(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Tan(P^);
end;

function OpASin(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  YYAssert((-1 <= P^) and (P^ <= 1), E_INVALID_PARAM);
  Result := ArcSin(P^);
end;

function OpACos(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  YYAssert((-1 <= P^) and (P^ <= 1), E_INVALID_PARAM);
  Result := ArcCos(P^);
end;

function OpATan(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := ArcTan(P^);
end;

function OpATan2(N: Integer; P: PDouble): Double;
var
  X, Y: Double;
begin
  YYAssert(N = 2, E_INVALID_PARAM);
  Y := P^;
  Inc(P);
  X := P^;
  Result := ArcTan2(Y, X);
end;

function OpExp(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Exp(P^);
end;

function OpMax(N: Integer; P: PDouble): Double;
var
  I: Integer;
begin
  YYAssert(N > 0, E_VALUE_NOT_ENOUGH);
  Result := P^;
  Inc(P);
  for I := 1 to N - 1 do
  begin
    Result := Max(Result, P^);
    Inc(P);
  end;
end;

function OpMin(N: Integer; P: PDouble): Double;
var
  I: Integer;
begin
  YYAssert(N > 0, E_VALUE_NOT_ENOUGH);
  Result := P^;
  Inc(P);
  for I := 1 to N - 1 do
  begin
    Result := Min(Result, P^);
    Inc(P);
  end;
end;

function OpSqrt(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  YYAssert(P^ >= 0, E_INVALID_PARAM);
  Result := Sqrt(P^);
end;

function OpLog(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Ln(P^);
end;

function OpLog10(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Log10(P^);
end;

function OpSinh(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Sinh(P^);
end;

function OpCosh(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Cosh(P^);
end;

function OpTanh(N: Integer; P: PDouble): Double;
begin
  YYAssert(N = 1, E_INVALID_PARAM);
  Result := Tanh(P^);
end;

function TYacc.OpUserFunc(FuncName, FuncDef: string; N: Integer; P: PDouble): Double;
// FuncDef: 'A, B','A+B'
var
  FD, Args: TStrings;
  I: Integer;
begin
  YYAssert(CycleList.IndexOf(FuncName) = -1, E_CIRCULATION);
  FD := TStringList.Create;
  Args := TStringList.Create;
  try
    FD.CommaText := FuncDef;
    with (TStringList.Create) do
    try
      CommaText := FD[0];
      YYAssert(Count = N, E_INVALID_PARAM);
      Args.AddStrings(ValueList);
      for I := N - 1 downto 0 do
      begin
        Args.Values[Strings[I]] := FloatToStr(P^);
        Inc(P);
      end;
      CycleList.Insert(0, FuncName);
      Result := CustomExpToFloat(FD[1], Args, UserList, CycleList);
      CycleList.Delete(0);
    finally
      Free;
    end;
  finally
    FD.Free;
    Args.Free;
  end;
end;

procedure TYacc.Init(VL, UL, CL: TStrings; MaxStackSize: Integer);
begin
  Assert(Assigned(VL));
  Assert(Assigned(UL));
  Assert(Assigned(CL));
  ValueList := VL;
  UserList := UL;
  CycleList := CL;
  SetLength(ValueStack, 0);

  FunctionList := TStringList.Create;
  with (FunctionList) do
  begin
    AddObject('SUM', @OpSum);
    AddObject('AVERAGE', @OpAverage);
    AddObject('STDEV', @OpStdev);
    AddObject('ABS', @OpAbs);
    AddObject('SIN', @OpSin);
    AddObject('COS', @OpCos);
    AddObject('TAN', @OpTan);
    AddObject('ASIN', @OpASin);
    AddObject('ACOS', @OpACos);
    AddObject('ATAN', @OpATan);
    AddObject('ATAN2', @OpATan2);
    AddObject('EXP', @OpExp);
    AddObject('MAX', @OpMax);
    AddObject('MIN', @OpMin);
    AddObject('SQRT', @OpSqrt);
    AddObject('LOG', @OpLog);
    AddObject('LOG10', @OpLog10);
    AddObject('SINH', @OpSinh);
    AddObject('COSH', @OpCosh);
    AddObject('TANH', @OpTanh);
  end;
end;

procedure TYacc.Term;
begin
  ValueList := nil;
  UserList := nil;
  CycleList := nil;
  SetLength(ValueStack, 0);
  FunctionList.Free;
end;

function TYacc.CallFunction(const ID: string; ArgCount: Integer): Double;
type
  TFuncCall = function (N: Integer; P: PDouble): Double;
var
  Index: Integer;
begin
  if (UserList.Values[ID] <> '') then
  begin
    Result := OpUserFunc(ID + '()', UserList.Values[ID], ArgCount, @ValueStack[CountStack - ArgCount]);
  end else
  begin
    Index := FunctionList.IndexOf(ID);
    YYAssert(Index >= 0, E_INVALID_FUNCTION + ID);
    Result := TFuncCall(FunctionList.Objects[Index])(ArgCount, @ValueStack[CountStack - ArgCount]);
  end;
  SetLength(ValueStack, CountStack - ArgCount);
end;

end.