//
// LexLib_Stream jbg for Delphi
//      by Osamu TAKEUCHI <osamu@big.or.jp>
//         http://www2.big.or.jp/~osamu/
//
//   LexLib jbg͂̃t@CƂƂɔzz YYParse.COD ev[g
//  ggāA *.Y t@C玩p[T[NX TLex ̔h
//  Ȃ TLexBase NX܂B
//
//  LexLib_Stream.LexBase 
//      ETStream ̓
//      ETStream ւ̏o
//  ̋@\܂B
//
//  ͕w肷ɂ
//      property InputStream: TStream; ͂ƂȂXg[w肷
//      property InputString: string;  ͂ƂȂ镶isj
//  ̂ǂ炩w肵܂BInputString ɕ͂ƁA
//  ŎI TMemoryStream AInputStream Ɋ蓖
//  ܂B TMemoryStream ͎Iɔj܂B̑
//  TStream  InputStream ɖIɊ蓖ĂꂽꍇATStream 
//  j܂B
//
//  o͕𓾂ɂ́AsO
//      property OutputStream: TStream; 
//  w肷邩AsO OutputStream:= nil ƂĂs
//      property OutputStream: TStream; 
//      property InputString: string;  ͂ƂȂ镶isj
//  ̂ǂ炩gēǂݏo܂B
//
//  ͂̉s͎I Lex ̃ftHgł #10 ɕϊ܂B
//  o͂̉s͕ϊ܂̂ŁAKvł΃R[hőΏKv
//  łB
//
//  TLexBase ̓JX^}CY邽 LexLib.TLexBase h
//  NXpӂATLex ͂̃NXh邱Ƃł܂B
//
//  R[h́Apꂽ LexLib.TLexBase ̎qNXK
//  SomeUnit.TLexBase ̌`̖O̂Ɖ肵܂B
//
//  .L  definitions ZNVɂ͕K
//  %{
//      unit UnitName;
//      interface
//      uses SomeLexLib, MyYacc;
//  %}
//  ̂TsLqĂB
//  UnitName  *.l t@C * ƓO
//  SomeLexLib ͎ۂ̓o̓[` TLexBase NX񋟂郆jbg
//  MyYacc  *.l Ƒgݍ킹Ďg *.y t@C琶郆jbg
//  ̑Kvȃjbg uses 邱Ƃł܂
//  ̑KvȃO[o錾ɒǉ邱Ƃł܂
//
//  .L  rules ZNV̐擪 TLex ̃o[錾ǉ邱Ƃł܂B
//    private
//      procedure SomeUtility;
//  sɃzCgXy[XȂ΂ȂȂƂɒӂĂB
//
//  .L  axiliary procedures ZNVɂ rules ZNVŒǉ錾
//  Ή`Ƃł܂B
//      procedure TLex.SomeUtility;
//      begin
//
//      end;
//
//  oオ SomeLex.pas jbĝ͎悤ɂĎgƂł܂B
//  ł TLexBase Ƃ LexLib_Stream.TLexBase gpƉ肵܂B
//
//    uses
//      SomeLex,        // lex  ɂ SomeLex.l  玩
//      SomeYacc;       // yacc ɂ SomeYacc.y 玩
//
//    var lex: TLex;    // lex  ɂ莩ꂽ SomeLex  Ɏ
//        yacc: TYacc;  // yacc ɂ莩ꂽ SomeYacc Ɏ
//    begin
//        lex := nil;
//        yacc:= nil;
//        try
//            lex := TLex.Create;
//            lex.InputString:= 'x=2*(3+2)'#10'x*3'#10;
//            yacc:= TYacc.Create(lex); // yacc  lex 蓖Ă
//            yacc.yyparse;             // p[XsI
//            WriteLn(lex.OutputString);// o͂R\[ɕ\
//        finally
//            yacc.Free;
//            lex.Free;
//        end;
//    end.
//

{$B-}
unit LexLib_Stream;

interface

uses SysUtils, Classes, LexLib;

const
    DefaultBufferSize= 1024;

type
TLexBase = class(LexLib.TLexBase)
  protected

    // o̓[`
    // TLex ́AR̃[`Ă̂ݓ́Eo͂ɃANZXB
    // u΁Ao͂̌`ύX邱Ƃł܂B

    function get_char : Char; override;
            // ͂ꕶǂŕԂ
            // ͂̏Ił #0 Ԃ
    procedure unget_char ( c : Char ); override;
            // ꕶ̓obt@ɏ߂B
            // ͎̕ get_char ōĂѓǂ݂܂B
    procedure put_char ( c : Char ); override;
            // o͂ɈꕶށB
public
    // 
    procedure yyinit; override;

    // I
    procedure yyfinal; override;

  private
    FInputStream, FOutputStream: TStream;
    function GetInputString: string;
    function GetOutputString: string;
    procedure SetInputStream(const Value: TStream);
    procedure SetInputString(const Value: string);
    procedure SetOutputStream(const Value: TStream);

  protected
    FMemInputStream, FMemOutputStream: TStream;
    FInputBuffer, FOutputBuffer, FUngetBuffer: string;
    FInputPtr, FOutputPtr, FUngetPtr: PChar;

  public
    constructor Create;
    destructor Destroy; override;
    property InputStream: TStream read FInputStream write SetInputStream;
    property OutputStream: TStream read FOutputStream write SetOutputStream;
    property InputString: string read GetInputString write SetInputString;
    property OutputString: string read GetOutputString;
end;

////////////////////////////////////////////////////////////////////
implementation
////////////////////////////////////////////////////////////////////

constructor TLexBase.Create;
begin
    inherited;
    FMemInputStream:= TMemoryStream.Create;
    FMemOutputStream:= TMemoryStream.Create;
end;

destructor TLexBase.Destroy;
begin
    inherited;
    FMemInputStream.Free;
    FMemOutputStream.Free;
end;

procedure TLexBase.yyinit;
begin
    inherited;
    SetLength(FInputBuffer, DefaultBufferSize);
    SetLength(FOutputBuffer, DefaultBufferSize);
    SetLength(FUngetBuffer, DefaultBufferSize);
    FOutputPtr:= PChar(FOutputBuffer);
    FUngetPtr:= PChar(FUngetBuffer);
    FInputPtr:= PChar(FInputBuffer)+Length(FInputBuffer);
    // string  #0 ^[~l[g͂
    if not Assigned(FOutputStream) then begin
        FMemOutputStream.Size:= 0;
        FOutputStream:= FMemOutputStream;
    end;
    yyuninit:= False;
end;

procedure TLexBase.yyfinal;
begin
    inherited;
    if FOutputPtr<>PChar(FOutputBuffer) then
        if Assigned(FOutputStream) then begin
            FOutputStream.Position:= FOutputStream.Size;
            FOutputStream.Write(FOutputBuffer[1], Integer(FOutputPtr)-Integer(PChar(FOutputBuffer)));
            FOutputStream.Position:= 0;
        end;
end;

/////////////////////////////////////////////////////////////////////////

function TLexBase.get_char: Char;
var p: PChar;
    bytes_read: Integer;
begin
    // unget_char ꂽ΂Ԃ
    if FUngetPtr<>PChar(FUngetBuffer) then begin
        Dec(FUngetPtr);
        Result:= FUngetPtr^;
        Exit;
    end;

    // yyline ɓǂ܂ĂȂ or yyline ׂĎg؂
    if (yycolno=0) or (yycolno>=Length(yyline)) then begin

        // sT -> p ɓ
        p:= FInputPtr;
        while True do begin
            while (p^<>#13) and (p^<>#10) do begin
                if p^=#0 then Break; // obt@[g؂
                Inc(p);
            end;
            // ׂ͂Ďg؂
            if not Assigned(FInputStream) or
                (FInputStream.Position=FInputStream.Size) then Break;
            // s𔭌iCRLF̑g𐳂ǂނ(p+1)^<>#0ɂj
            if (p^<>#0) and ((p+1)^<>#0) then Break; // p^=#0 Ȃ (p+1)^ ͕]Ȃ

            // obt@[g؂̂ŃXg[ǂݍ
            if FInputPtr<>PChar(FInputBuffer) then begin
                // Jl߂Ăɓǂݍ
                Move(FInputPtr^, PChar(FInputBuffer)^, StrLen(FInputPtr)+1);
                p:= p - ( Integer(FInputPtr) - Integer(PChar(FInputBuffer)) );
                FInputPtr:= PChar(FInputBuffer);
            end else begin
                // obt@LĂɓǂݍ
                SetLength(FInputBuffer, Length(FInputBuffer)*2);
                p:= p + Integer(PChar(FInputBuffer)) - Integer(FInputPtr);
                FInputPtr:= PChar(FInputBuffer);
                PChar(FInputBuffer)[Length(FInputBuffer) div 2]:= #0;
            end;
            if Assigned(FInputStream) then begin
                bytes_read:= Integer(StrLen(PChar(FInputBuffer)));
                bytes_read:= bytes_read+FInputStream.Read(
                        (PChar(FInputBuffer)+StrLen(PChar(FInputBuffer)))^,
                        (Length(FInputBuffer)-Integer(StrLen(PChar(FInputBuffer)))));
                PChar(FInputBuffer)[bytes_read]:= #0;
            end;
        end;

        if (p^<>#13) and (p^<>#10) then begin
            yyline:= StrPas(FInputPtr);
            FInputPtr:= p;
        end else
        if (p^<>(p+1)^) and (((p+1)^=#10) or ((p+1)^=#13)) then begin
            p^:= #0;
            yyline:= StrPas(FInputPtr)+#10;
            FInputPtr:= p+2;
        end else begin
            p^:= #0;
            yyline:= StrPas(FInputPtr)+#10;
            FInputPtr:= p+1;
        end;
        Inc(yylineno);
        yycolno:= 0;
    end;

    Inc(yycolno);
    Result:= (PChar(yyline)+yycolno-1)^;
end;

procedure TLexBase.put_char(c: Char);
begin
    if FOutputPtr>=PChar(FOutputBuffer)+Length(FOutputBuffer) then begin
        FOutputStream.Write(FOutputBuffer[1], Length(FOutputBuffer));
        FOutputPtr:= PChar(FOutputBuffer);
    end;
    FOutputPtr^:= c;
    Inc(FOutputPtr);
end;

procedure TLexBase.unget_char(c: Char);
begin
    if FUngetPtr>=PChar(FUngetBuffer)+Length(FUngetBuffer) then 
        SetLength(FUngetBuffer, Length(FUngetBuffer)*2);
    FUngetPtr^:= c;
    Inc(FUngetPtr);
end;

/////////////////////////////////////////////////////////////////////////

function TLexBase.GetInputString: string;
begin
    Result:= '';
    if FInputStream.Size>0 then begin
        FInputStream.Position:= 0;
        SetLength(Result, FInputStream.Size);
        FInputStream.Read(Result[1], FInputStream.Size);
    end;
end;

function TLexBase.GetOutputString: string;
begin
    Result:= '';
    if FOutputStream.Size>0 then begin
        FOutputStream.Position:= 0;
        SetLength(Result, FOutputStream.Size);
        FOutputStream.Read(Result[1], FOutputStream.Size);
    end;
end;

procedure TLexBase.SetInputStream(const Value: TStream);
begin
    FInputStream:= Value;
end;

procedure TLexBase.SetInputString(const Value: string);
begin
    FInputStream:= FMemInputStream;
    FMemInputStream.Position:= 0;
    FMemInputStream.Write(Value[1], Length(Value));
    FMemInputStream.Position:= 0;
end;

procedure TLexBase.SetOutputStream(const Value: TStream);
begin
    FOutputStream:= Value;
end;

end.
