unit MainFrm;
{*******************************************************************************
  
  $Author: kumagai $
  $Date: 2002/09/24 22:50:07 $
  $Revision: 1.1.1.1 $
*******************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmMain = class(TForm)
    btnCalc: TButton;
    memExp: TMemo;
    memValue: TMemo;
    memResult: TMemo;
    btnClear: TButton;
    btnClose: TButton;
    procedure btnCalcClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  ExpUtils;

procedure TfrmMain.btnCalcClick(Sender: TObject);
var
  I: Integer;
begin
  memResult.Clear;
  for I := 0 to memExp.Lines.Count - 1 do
  begin
    try
      memResult.Lines.Add(FloatToStr(ExpToFloat(memExp.Lines[I], memValue.Lines)));
    except
      on E: Exception do  memResult.Lines.Add(E.Message);
    end;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  memExp.Clear;
  memValue.Clear;
  memResult.Clear;
  memExp.Lines.Add('123+1');
  memExp.Lines.Add('0x00A');
  memExp.Lines.Add('100h');
  memExp.Lines.Add('101b');
  memExp.Lines.Add('010');
  memExp.Lines.Add('A + 1');
  memExp.Lines.Add('A + B / C');
  memExp.Lines.Add('(1+2)/2');
  memExp.Lines.Add('SUM(1,2,3)');
  memExp.Lines.Add('AVERAGE(1,4,5,6,7)');
  memExp.Lines.Add('STDEV(1,2,3,4,5,6)');
  memExp.Lines.Add('ABS(123)');
  memExp.Lines.Add('ABS(-123)');
  memExp.Lines.Add('SIN(1/4 * PI)');
  memExp.Lines.Add('COS(1/4 * PI)');
  memExp.Lines.Add('TAN(1/4 * PI)');
  memExp.Lines.Add('SINH(1/4)');
  memExp.Lines.Add('COSH(1/4)');
  memExp.Lines.Add('TANH(1/4)');
  memExp.Lines.Add('ASIN(SIN(1/4))');
  memExp.Lines.Add('ACOS(COS(1/4))');
  memExp.Lines.Add('ATAN(TAN(1/4))');
  memExp.Lines.Add('ATAN2(1, 0)');
  memExp.Lines.Add('ATAN2(1, 1) / PI * 4');
  memExp.Lines.Add('MAX(-12, 1, 2, 5, 0)');
  memExp.Lines.Add('MIN(-12, 1, 2, 5, 0)');

  memExp.Lines.Add('SQRT(2)');
  memExp.Lines.Add('SQRT(3)');

  memExp.Lines.Add('EXP(2)');
  memExp.Lines.Add('LOG(2)');
  memExp.Lines.Add('LOG10(2)');
  memExp.Lines.Add('F(1)');
  memExp.Lines.Add('G(1,2)');
  memExp.Lines.Add('Sphere(10, 1, 0)');
  memExp.Lines.Add('ASP(10, 1, 0)');
  memExp.Lines.Add('ASP(10, 2, 0)');
  memExp.Lines.Add('ASP(10, 3, 0)');

  memValue.Lines.Values['A'] := '123';
  memValue.Lines.Values['B'] := '456';
  memValue.Lines.Values['C'] := '789';
  memValue.Lines.Values['F(X)'] := 'X + 1';
  memValue.Lines.Values['G(A,B)'] := 'A + 10 * B';
  memValue.Lines.Values['Sphere(R0, Y, K)'] := '-(Y^2) / (R0 + R0 * Sqrt(1 - (1 + K) * (Y / R0)^2))';
  memValue.Lines.Values['A2'] := '1E-2';
  memValue.Lines.Values['A4'] := '1E-4';
  memValue.Lines.Values['A8'] := '1E-8';
  memValue.Lines.Values['ASP(R0, Y, K)'] := 'Sphere(R0, Y, K) + A2 * Y^2 + A4 * Y^4 + A8 * Y^8';
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  memResult.Clear;
end;

end.
